module Main(main) where

import Communicate
import System
import GameState
import Network
import Robot
import MainStrategy
import Board

main = getArgs >>= maini

maini args = withSocketsDo $
	     case args of
	     (server:port:_) ->
	          do (h,state) <- Communicate.init server
				   (toInteger (mkInt port))
		     putStr "\ESC[2J"
                     mainLoop h (mkInitState state) mainStrategy
	     _ -> do putStrLn "Incorrect use!"
		     putStrLn "Needs two arguments: server and portnumber"

mainLoop h state strat = do -- putStrLn "New loop" -- debug
		            pkg <- getPackages h
		            let state' = considerPacks state pkg
{-
		            putStrLn ("State: " ++ show state')
		            putStrLn ("Bases: " ++ show (notVisitedHomeBases state'))
		            putStrLn ("MyPos: " ++ show (myPos state'))
                            putStrLn ("Shortest: " ++ show (shortestPath
                                                             (board state) (myPos state')
                                                               (head (notVisitedHomeBases state'))))
-}
{-
			    putStrLn (showState state')
			    putStrLn (show (myPacks state'))
			    putStrLn (show (score state'))
-}
		            let (comm,strat') = run state' strat
		            --putStrLn ("Command: " ++ show comm)
		            --putStrLn "Got packages" -- debug
		            sendAction h comm
		            --putStrLn "Sent action" -- debug
		            resp <- getResponse h (myId state')
		            --putStrLn "Got Response" -- debug
			    --getLine
		            mainLoop h (newState resp state') strat'
