module MainStrategy where

import Commands
import Maybe
import Robot
import Strategy
import ExploreStrategy
import PickStrategy
import SafetyStrategy
import PickStrategy
import DeliverStrategy
import DetourStrategy

---------------------------------------------------------------------------
-- main strategy

mainStrategy :: Rob Command
mainStrategy =
  safetyStrategy
  ( exploreStrategy
      `switch` ( pickStrategy
             .|. detourStrategy
             .|. deliverStrategy
               ) ==> \comm -> shift comm mainStrategy
  )
